using System.ComponentModel.DataAnnotations;
using Managing.Domain.Users;
using Orleans;
using static Managing.Common.Enums;

namespace Managing.Domain.Accounts;

[GenerateSerializer]
public class Account
{
    [Id(0)]
    [Required] public string Name { get; set; }
    
    [Id(1)]
    [Required] public TradingExchanges Exchange { get; set; }
    
    [Id(2)]
    [Required] public AccountType Type { get; set; }
    
    [Id(3)]
    public string Key { get; set; }
    
    [Id(4)]
    public string Secret { get; set; }
    
    [Id(5)]
    public User User { get; set; }
    
    [Id(6)]
    public List<Balance> Balances { get; set; }

    public bool IsPrivyWallet => Type == AccountType.Privy;
}